package bundle;

import org.jboss.spring.vfs.context.VFSClassPathXmlApplicationContext;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class Activator implements BundleActivator {

    public Activator() {
        workaroundJBossBug();
    }

    @Override
    public void start(BundleContext context) throws Exception {

        Object springSimpleBean = null;
        Object springPatternBean = null;
        Object snowdropSimpleBean = null;
        Object snowdropPatternBean = null;

        try {
            AbstractApplicationContext springSimple = new ClassPathXmlApplicationContext("classpath:spring/applicationContext.xml");
            springSimpleBean = springSimple.getBean("testBean");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        try {
            AbstractApplicationContext springPattern = new ClassPathXmlApplicationContext("classpath:spring/*Context.xml");
            springPatternBean = springPattern.getBean("testBean");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }

        try {
            AbstractApplicationContext snowdropSimple = new VFSClassPathXmlApplicationContext("classpath:spring/applicationContext.xml");
            snowdropSimpleBean = snowdropSimple.getBean("testBean");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }

        try {
            AbstractApplicationContext snowdropPattern = new VFSClassPathXmlApplicationContext("classpath:spring/*Context.xml");
            snowdropPatternBean = snowdropPattern.getBean("testBean");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }

        System.out.println("Spring simple bean = " + springSimpleBean);
        System.out.println("Spring pattern bean = " + springPatternBean);
        System.out.println("Snowdrop simple bean = " + snowdropSimpleBean);
        System.out.println("Snowdrop pattern bean = " + snowdropPatternBean);
    }

    @Override
    public void stop(BundleContext context) throws Exception {
    }

    private void workaroundJBossBug() {
        ClassLoader classClassLoader = getClass().getClassLoader();
        Thread.currentThread().setContextClassLoader(classClassLoader);
    }
}
